local helper = wesnoth.require "lua/helper.lua"
--local debug_utils = wesnoth.require "~add-ons/World_of_Wesnoth/lua/utils.lua"

function wesnoth.wml_actions.character_creation(cfg)
	local side_number = wesnoth.get_variable("side_number")
	local former_unit=0
	local unit=1
	local c_strength=10
	local c_dexterity=10
	local c_endurance=10
	local c_intelligence=10
	local cc_strength=0
	local cc_dexterity=0
	local cc_endurance=0
	local cc_intelligence=0
	local c_class="Barbarian"
	local c_gender="male"
	local c_race="Human"
	local c_name="Annihilator"
	local cc_class = 1
	local cc_gender = 1
	local cc_race = 1
	local first_dialog = { T.tooltip { id = "tooltip_large" }, T.helptip { id = "tooltip_large" }, maximum_width = 800, maximum_height = 600,
		T.grid {
			T.row { T.column { T.label { id="title" , definition="title" , label="Create your hero"} }} ,
			T.row { T.column { T.grid { T.row {
				T.column { T.grid { 
					T.row { T.column { T.label { label="Class:"} }},
					T.row { T.column { horizontal_grow = "false" , grow_factor=1 , horizontal_alignment = "left" , vertical_alignment = "top" , border= "All" , border_size = 5, T.scroll_label { id = "gui_class_description", label=""} }},
					T.row { T.column { horizontal_grow = true, T.listbox { id = "gui_class_chosen", 
						T.list_definition { T.row { T.column { horizontal_grow = true,
							T.toggle_panel { tooltip="The choice of class is the most important one. It makes you choose the intended play style. You will be later allowed to select more than one class. Choose the race and attributes to suit the class selected.", T.grid { T.row {
			   					T.column { horizontal_alignment = "left", T.label { id = "gui_class_name" } },
								T.column { T.image { id = "gui_class_icon" } }
							}}}
						}}}
					}}}
				}},
				T.column { T.grid { 
					T.row { T.column { T.grid { T. row { T.column { T.label { label="Name:"} }, T.column { T.text_box { id="gui_name" , label=c_name }}}}}},
					T.row { T.column { T.label { label="Gender:"} }},
					T.row { T.column { horizontal_grow = true, T.listbox { id = "gui_gender_chosen", vertical_scrollbar_mode=false,
						T.list_definition { T.row { T.column { horizontal_grow = true,
							T.toggle_panel { tooltip="The choice of gender is only esthetical.", T.grid { T.row {
			   					T.column { horizontal_alignment = "left", T.label { id = "gui_gender_name" } },
								T.column { T.image { id = "gui_gender_icon" } }
							}}}
						}}}
					}}},
					T.row { T.column { T.label { label="Race:"} }},
					T.row { T.column { T.label { id = "gui_race_description", label=""}}},
					T.row { T.column { horizontal_grow = true, T.listbox { id = "gui_race_chosen",
						T.list_definition { T.row { T.column { horizontal_grow = true,
							T.toggle_panel {tooltip="The choice of race has an impact on attributes, appearance and some abilities, but it is not as important than the choice of class.", T.grid { T.row {
			   					T.column { horizontal_alignment = "left", T.label { id = "gui_race_name" } },
								T.column { T.image { id = "gui_race_icon" } }
							}}}
						}}}
					}}},
					T.row { T.column { T.grid {
						T.row {
							T.column { T.label { label="Strength (+0):"  , id="gui_strength_bonus", tooltip="Strength determines the damage a character deals and the ability to carry heavy armours. The number in brackets determines the way the race selected affects it."} },
							T.column { T.label { label="10"  , id="gui_strength", tooltip="Strength determines the damage a character deals. The number in brackets determines the way the race selected affects it."} },
							T.column { T.slider { minimum_value=-5 , maximum_value=5 , step_size=1, value=cc_strength, id="gui_strength_modifier" , tooltip="Strength determines the damage a character deals. The number in brackets determines the way the race selected affects it."} },
							T.column { T.label { label=""  , id="gui_strength_importance"} }
						},
						T.row {
							T.column { T.label { label="Dexterity (+0):" , id="gui_dexterity_bonus" , tooltip="Dexterity determines the chance that the character gets hit, the chance to hit and the damage with ranged weapons. The number in brackets determines the way the race selected affects it."} },
							T.column { T.label { label="10" , id="gui_dexterity" , tooltip="Dexterity determines the chance that the character gets hit. The number in brackets determines the way the race selected affects it."} },
							T.column { T.slider { minimum_value=-5 , maximum_value=5 , step_size=1, value=cc_dexterity, id="gui_dexterity_modifier" , tooltip="Dexterity determines the chance that the character gets hit. The number in brackets determines the way the race selected affects it." } },
							T.column { T.label { label=""  , id="gui_dexterity_importance"} }
						},
						T.row {
							T.column { T.label { label="Endurance (+0):" , id="gui_endurance_bonus", tooltip="Endurance determines how many hitpoints the character has. The number in brackets determines the way the race selected affects it." } },
							T.column { T.label { label="10" , id="gui_endurance", tooltip="Endurance determines how many hitpoints the character has. The number in brackets determines the way the race selected affects it." } },
							T.column { T.slider { minimum_value=-5 , maximum_value=5 , step_size=1, value=cc_endurance, id="gui_endurance_modifier", tooltip="Endurance determines how many hitpoints the character has. The number in brackets determines the way the race selected affects it." } },
							T.column { T.label { label=""  , id="gui_endurance_importance"} }
						},
						T.row {
							T.column { T.label { label="Intelligence (+0):" , id="gui_intelligence_bonus", tooltip="Intelligence determines the amount of mana (magical power) the character can have. The number in brackets determines the way the race selected affects it." } },
							T.column { T.label { label="10" , id="gui_intelligence", tooltip="Intelligence determines the amount of mana (magical power) the character can have. The number in brackets determines the way the race selected affects it." } },
							T.column { T.slider { minimum_value=-5 , maximum_value=5 , step_size=1, value=cc_intelligence, id="gui_intelligence_modifier", tooltip="Intelligence determines the amount of mana (magical power) the character can have. The number in brackets determines the way the race selected affects it." } },
							T.column { T.label { label=""  , id="gui_intelligence_importance"} }
						},
						T.row {
							T.column { T.label { label="Sum of attributes:" , tooltip="The sum of attribute modifiers must be 0." } },
							T.column { T.label { label="0" , tooltip="The sum of attribute modifiers must be 0." , id="gui_attributes_sum" } },
							T.column { T.label { label="" , tooltip="The sum of attribute modifiers must be 0."} },
							T.column { T.button { id = "gui_calc_attribs", label = "Validate" , tooltip="You have to hit this after changing attributes to verify if their sum is 0 as it must be and to see what your final attributes will be."} }
						}
					}}}
				}}
			}}}},
			T.row { T.column { T.grid { T.row {
				T.column { T.button { id = "ok", label = "Choose" } },
				T.column { T.button { id = "cancel", label = "Back" } }
			}}}}
		}}
	local quick_revision_dialog = { T.tooltip { id = "tooltip_large" }, T.helptip { id = "tooltip_large" },
		T.grid {
			T.row { T.column { T.label { id="gui_hero_name" , definition="title" , label=""} }} ,
			T.row { T.column { T.label { id="gui_class" , tooltip = "Class chosen", label=""} }} ,
			T.row { T.column { T.label { id="gui_gender" , tooltip = "Gender chosen", label=""} }} ,
			T.row { T.column { T.label { id="gui_race" , tooltip = "Race chosen", label=""} }} ,
			T.row { T.column { T.grid {
				T.row {
					T.column { T.label { label="Strength:"  , tooltip="Strength determines the damage a character deals."} },
					T.column { T.label { label="10"  , id="gui_strength", tooltip="Strength determines the damage a character deals."} }
				},
				T.row {
					T.column { T.label { label="Dexterity:" ,  tooltip="Dexterity determines the chance that the character gets hit."} },
					T.column { T.label { label="10" , id="gui_dexterity" , tooltip="Dexterity determines the chance that the character gets hit."} }
				},
				T.row {
					T.column { T.label { label="Endurance:" , tooltip="Endurance determines how many hitpoints the character has." } },
					T.column { T.label { label="10" , id="gui_endurance", tooltip="Endurance determines how many hitpoints the character has.." } }
				},
				T.row {
					T.column { T.label { label="Intelligence:" , tooltip="Intelligence determines the amount of mana (magical power) the character can have." } },
					T.column { T.label { label="10" , id="gui_intelligence", tooltip="Intelligence determines the amount of mana (magical power) the character can have." } }
				},
			}}},
			T.row { T.column { T.grid { T.row {
				T.column { T.button { id = "ok", label = "Accept" } },
				T.column { T.button { id = "cancel", label = "Decline" } }
			}}}}
		}}
	local function calculate_attributes()
		cc_strength = wesnoth.get_dialog_value "gui_strength_modifier"
		cc_dexterity= wesnoth.get_dialog_value "gui_dexterity_modifier"
		cc_endurance= wesnoth.get_dialog_value "gui_endurance_modifier"
		cc_intelligence= wesnoth.get_dialog_value "gui_intelligence_modifier"
		c_strength= 10 + cc_strength
		c_dexterity= 10 + cc_dexterity
		c_endurance= 10 + cc_endurance
		c_intelligence= 10 + cc_intelligence
		local preshow_race_selected = wesnoth.get_dialog_value "gui_race_chosen"
		if preshow_race_selected == 3 then
			c_strength = c_strength + 2
			c_intelligence = c_intelligence -3
			c_endurance = c_endurance + 1
		end
		if preshow_race_selected == 2 then
			c_dexterity = c_dexterity + 3
			c_endurance = c_endurance - 3
		end
	end
	local function first_preshow()
		local function select_attribute()
			local attributes_sum = wesnoth.get_dialog_value "gui_strength_modifier" +  wesnoth.get_dialog_value "gui_dexterity_modifier" + wesnoth.get_dialog_value "gui_endurance_modifier" + wesnoth.get_dialog_value "gui_intelligence_modifier"
			wesnoth.set_dialog_value( attributes_sum , "gui_attributes_sum")
			if attributes_sum ~= 0 then
				wesnoth.set_dialog_active( false, "ok")
			end
			if attributes_sum == 0 then
				wesnoth.set_dialog_active( true, "ok")
			end
			calculate_attributes()
			wesnoth.set_dialog_value(c_strength, "gui_strength")
			wesnoth.set_dialog_value(c_dexterity, "gui_dexterity")
			wesnoth.set_dialog_value(c_endurance, "gui_endurance")
			wesnoth.set_dialog_value(c_intelligence, "gui_intelligence")
		end
		local function select()
			local preshow_class_selected = wesnoth.get_dialog_value "gui_class_chosen"
			local preshow_race_selected = wesnoth.get_dialog_value "gui_race_chosen"
			wesnoth.set_dialog_value("", "gui_strength_importance")
			wesnoth.set_dialog_value("", "gui_dexterity_importance")
			wesnoth.set_dialog_value("", "gui_endurance_importance")
			wesnoth.set_dialog_value("", "gui_intelligence_importance")
			if preshow_class_selected == 1 then
				wesnoth.set_dialog_value("Barbarian is the mighest melee warrior, with almost all abilities related to melee combat. Barbarians can withstand incredible damages and defeat many enemies with brute force. The only magic a Barbarian knows are a few shamanic spells.", "gui_class_description")
				wesnoth.set_dialog_value("Important", "gui_strength_importance")
				wesnoth.set_dialog_value("Important", "gui_endurance_importance")
			end
			if preshow_class_selected == 2 then
				wesnoth.set_dialog_value("Fencers are agile fighters who prefer dexterity and wit over brute force. Their combat style is based on using dexterity where others use strength. Fencers have also a basic magic training.", "gui_class_description")
				wesnoth.set_dialog_value("Crucial", "gui_dexterity_importance")
			end
			if preshow_class_selected == 3 then
				wesnoth.set_dialog_value("Hunters are fighters focused on usage of bows and knowledge of woodlands. Forest is their region, they can control the forces of nature, and their skill with sword can come handy sometimes as well.", "gui_class_description")
				wesnoth.set_dialog_value("Important", "gui_strength_importance")
				wesnoth.set_dialog_value("Important", "gui_dexterity_importance")
			end
			if preshow_class_selected == 4 then
				wesnoth.set_dialog_value("Rogue is the least honest of any fighter a man can find. Poisoning their blades, hiding, attacking from the back and confusing enemies with shadow magic is their favourite combat technique.", "gui_class_description")
				wesnoth.set_dialog_value("Important", "gui_intelligence_importance")
				wesnoth.set_dialog_value("Important", "gui_dexterity_importance")
			end
			if preshow_class_selected == 5 then
				wesnoth.set_dialog_value("Cleric is a spellcaster whose faith is stronger than anything. Their faith leads them when healing allies, when casting spells, when enchanting allies to fight better, or even when they fight themselves.", "gui_class_description")
				wesnoth.set_dialog_value("Important", "gui_intelligence_importance")
				wesnoth.set_dialog_value("Useful", "gui_strength_importance")
			end
			if preshow_class_selected == 6 then
				wesnoth.set_dialog_value("Wizards are undeniably the strongest spellcasters. They magic is heavily focused on destroying enemies with fire and ice, but they can also cast a few defensive spells.", "gui_class_description")
				wesnoth.set_dialog_value("Crucial", "gui_intelligence_importance")
			end
			if preshow_class_selected == 7 then
				wesnoth.set_dialog_value("Necromancer is a specialist on raising terrible undead armies and crippling enemies with various curses and poisons, with a skeletal figure affecting reistances. Necromancers are specialist spellcasters, and generally weak in melee combat.", "gui_class_description")
				wesnoth.set_dialog_value("Important", "gui_intelligence_importance")
				wesnoth.set_dialog_value("Useful", "gui_endurance_importance")
			end
			if preshow_race_selected == 1 then
				wesnoth.set_dialog_value("Special: +1 mana regeneration, magic resistance", "gui_race_description")
				wesnoth.set_dialog_value("Strength (+0):", "gui_strength_bonus")
				wesnoth.set_dialog_value("Dexterity (+0):", "gui_dexterity_bonus")
				wesnoth.set_dialog_value("Endurance (+0):", "gui_endurance_bonus")
				wesnoth.set_dialog_value("Intelligence (+0):", "gui_intelligence_bonus")
			end
			if preshow_race_selected == 2 then
				wesnoth.set_dialog_value("Special: faerie powers, good at forests", "gui_race_description")
				wesnoth.set_dialog_value("Strength (+0):", "gui_strength_bonus")
				wesnoth.set_dialog_value("Dexterity (+3):", "gui_dexterity_bonus")
				wesnoth.set_dialog_value("Endurance (-3):", "gui_endurance_bonus")
				wesnoth.set_dialog_value("Intelligence (+0):", "gui_intelligence_bonus")
			end
			if preshow_race_selected == 3 then
				wesnoth.set_dialog_value("Special: berserker fury ability", "gui_race_description")
				wesnoth.set_dialog_value("Strength (+2):", "gui_strength_bonus")
				wesnoth.set_dialog_value("Dexterity (+0):", "gui_dexterity_bonus")
				wesnoth.set_dialog_value("Endurance (+1):", "gui_endurance_bonus")
				wesnoth.set_dialog_value("Intelligence (-3):", "gui_intelligence_bonus")
			end
			select_attribute()
		end
		local function select_gender()
			local preshow_gender_selected = wesnoth.get_dialog_value "gui_gender_chosen"
			local preshow_name = wesnoth.get_dialog_value "gui_name"
			if preshow_gender_selected == 2 and preshow_name == "Annihilator" then
				wesnoth.set_dialog_value("Annihilatrix", "gui_name")
			end
			if preshow_gender_selected == 1 and preshow_name == "Annihilatrix" then
				wesnoth.set_dialog_value("Annihilator", "gui_name")
			end
		end
		wesnoth.set_dialog_callback(select, "gui_class_chosen")
		wesnoth.set_dialog_callback(select, "gui_race_chosen")
		wesnoth.set_dialog_callback(select_gender, "gui_gender_chosen")
		wesnoth.set_dialog_callback(select_attribute, "gui_calc_attribs")
		wesnoth.set_dialog_value("Barbarian", "gui_class_chosen", 1, "gui_class_name")
		wesnoth.set_dialog_value("units/orcs/warrior.png~RC(magenta>black)", "gui_class_chosen", 1, "gui_class_icon")
		wesnoth.set_dialog_value("Fencer", "gui_class_chosen", 2, "gui_class_name")
		wesnoth.set_dialog_value("units/human-loyalists/fencer.png~RC(magenta>blue)", "gui_class_chosen", 2, "gui_class_icon")
		wesnoth.set_dialog_value("Hunter", "gui_class_chosen", 3, "gui_class_name")
		wesnoth.set_dialog_value("units/elves-wood/ranger+female.png~RC(magenta>green)", "gui_class_chosen", 3, "gui_class_icon")
		wesnoth.set_dialog_value("Rogue", "gui_class_chosen", 4, "gui_class_name")
		wesnoth.set_dialog_value("units/human-outlaws/assassin.png~RC(magenta>black)", "gui_class_chosen", 4, "gui_class_icon")
		wesnoth.set_dialog_value("Cleric", "gui_class_chosen", 5, "gui_class_name")
		wesnoth.set_dialog_value("units/human-magi/white-mage.png~RC(magenta>white)", "gui_class_chosen", 5, "gui_class_icon")
		wesnoth.set_dialog_value("Wizard", "gui_class_chosen", 6, "gui_class_name")
		wesnoth.set_dialog_value("units/human-magi/elder-mage.png~RC(magenta>red)", "gui_class_chosen", 6, "gui_class_icon")
		wesnoth.set_dialog_value("Necromancer", "gui_class_chosen", 7, "gui_class_name")
		wesnoth.set_dialog_value("units/undead-necromancers/ancient-lich.png~RC(magenta>black)", "gui_class_chosen", 7, "gui_class_icon")
		wesnoth.set_dialog_value(cc_class, "gui_class_chosen")
		wesnoth.set_dialog_value("Male", "gui_gender_chosen", 1, "gui_gender_name")
		wesnoth.set_dialog_value("units/elves-wood/hero.png~RC(magenta>blue)", "gui_gender_chosen", 1, "gui_gender_icon")
		wesnoth.set_dialog_value("Female", "gui_gender_chosen", 2, "gui_gender_name")
		wesnoth.set_dialog_value("units/elves-wood/sylph.png~RC(magenta>red)", "gui_gender_chosen", 2, "gui_gender_icon")
		wesnoth.set_dialog_value(cc_gender, "gui_gender_chosen")
		wesnoth.set_dialog_value("Human", "gui_race_chosen", 1, "gui_race_name")
		wesnoth.set_dialog_value("units/human-loyalists/general.png~RC(magenta>blue)", "gui_race_chosen", 1, "gui_race_icon")
		wesnoth.set_dialog_value("Elf", "gui_race_chosen", 2, "gui_race_name")
		wesnoth.set_dialog_value("units/elves-wood/high-lord.png~RC(magenta>green)", "gui_race_chosen", 2, "gui_race_icon")
		wesnoth.set_dialog_value("Orc", "gui_race_chosen", 3, "gui_race_name")
		wesnoth.set_dialog_value("units/orcs/warlord.png~RC(magenta>black)", "gui_race_chosen", 3, "gui_race_icon")
		wesnoth.set_dialog_value(cc_race, "gui_race_chosen")
		select()
	end

	local function quick_revision_preshow()
		wesnoth.set_dialog_value(c_name, "gui_hero_name")
		wesnoth.set_dialog_value(c_class, "gui_class")
		wesnoth.set_dialog_value(c_gender, "gui_gender")
		wesnoth.set_dialog_value(c_race, "gui_race")
		wesnoth.set_dialog_value(c_strength, "gui_strength")
		wesnoth.set_dialog_value(c_dexterity, "gui_dexterity")
		wesnoth.set_dialog_value(c_endurance, "gui_endurance")
		wesnoth.set_dialog_value(c_intelligence, "gui_intelligence")
	end

	local function first_postshow()
		cc_class = wesnoth.get_dialog_value "gui_class_chosen"
		cc_race = wesnoth.get_dialog_value "gui_race_chosen"
		cc_gender = wesnoth.get_dialog_value "gui_gender_chosen"
		c_name = wesnoth.get_dialog_value "gui_name"
		calculate_attributes()
	end
	local function quick_revision_postshow()
	end

	local r = -2
	local choice_done = -2
	while choice_done == -2 do
		r = wesnoth.show_dialog(first_dialog, first_preshow, first_postshow)
		if r == -1 then
			if cc_class == 1 then
				c_class = "Barbarian"
			end
			if cc_class == 2 then
				c_class = "Fencer"
			end
			if cc_class == 3 then
				c_class = "Hunter"
			end
			if cc_class == 4 then
				c_class = "Rogue"
			end
			if cc_class == 5 then
				c_class = "Cleric"
			end
			if cc_class == 6 then
				c_class = "Wizard"
			end
			if cc_class == 7 then
				c_class = "Necromancer"
			end
			if cc_race == 1 then
				c_race = "Human"
			end
			if cc_race == 2 then
				c_race = "Elf"
			end
			if cc_race == 3 then
				c_race = "Orc"
			end
			if cc_gender == 1 then
				c_gender = "male"
			end
			if cc_gender == 2 then
				c_gender = "female"
			end
			choice_done = wesnoth.show_dialog(quick_revision_dialog, quick_revision_preshow, quick_revision_postshow)
		else
			choice_done=-1
		end
	end
	if r == -1 then
		former_unit = wesnoth.get_units { canrecruit=true , side=side_number }
		raw_unit = wesnoth.create_unit { type="Hero", gender=c_gender, x=former_unit[1].x, y=former_unit[1].y, canrecruit=true, side=side_number, name=c_name, { "variables" , {{"a", { id=11000+cc_class*100+1, }},{"a", { id=60000+cc_class}} ,{"a", { id=100+c_strength}},{"a", { id=200+c_dexterity}},{"a", { id=300+c_endurance}},{"a", { id=400+c_intelligence}},{"a", { id=300+c_endurance}},{"a", { id=cc_race}}, mana = c_intelligence, max_mana = c_intelligence, mana_to_pay=0 } }}
		unit = raw_unit.__cfg
		unit = wesnoth.update_stats(unit)
		wesnoth.put_unit(unit)
	else
		wesnoth.fire_event("side turn 1")		
	end
end


