local helper = wesnoth.require "lua/helper.lua"
local T = helper.set_wml_tag_metatable {}
--local debug_utils = wesnoth.require "~add-ons/World_of_Wesnoth/lua/utils.lua"

function wesnoth.wml_actions.put_item(cfg)
	local number = cfg.id or helper.wml_error "[put_item] missing required id value"
	local coord_x = cfg.x or helper.wml_error "[put_item] missing required x value"
	local coord_y = cfg.y or helper.wml_error "[put_item] missing required y value"
	local raw_items = wesnoth.get_variable "items" or {}
	local item_code = { "item" , { id = number , x = coord_x , y = coord_y}}
	local items = {}
	items[2]=raw_items
	items[1]="items"
	items[2][#items[2]+1] = item_code
	wesnoth.set_variable("items",items[2])
	if number <70000  and number >= 60000 then
		local item_code_picked = uniques[number-60000][2]
		item_appearance = item_code_picked.image or helper.wml_error("Item" .. number .. "is missing its on-ground image")
		if item_code_picked.graphics_mod then
			item_appearance = item_appearance .. item_code_picked.graphics_mod
		end
	end
	if number <1000000  and number >= 200000 then
		local base_item = base_items[((number - 200000) % 10000 - (number - 200000) % 100)/100][2] or helper.wml_error("Base item of" .. number .. "is not defined")
		item_appearance = base_item.image or helper.wml_error("Item" .. number "is missing its on-ground image")
		if base_item.graphics_mod then
			item_appearance = item_appearance .. base_item.graphics_mod
		end
		if number > 210100 then
			local prefix = prefixes[(number - 200000 - (number - 200000) % 10000)/10000][2] or helper.wml_error("Prefix of" .. number .. "is not defined")
			if prefix.graphics_mod then
				item_appearance = item_appearance .. prefix.graphics_mod
			end
		end
		if number % 100 > 0 then
			local suffix = suffixes[ number % 100][2] or helper.wml_error("Suffix of" .. number .. "is not defined")
			if suffix.graphics_mod then
				item_appearance = item_appearance .. suffix.graphics_mod
			end
		end
	end
	if item_appearance then
		wesnoth.wml_actions.item({ x=coord_x , y=coord_y, image=item_appearance, halo="halo/misc/leadership-flare-1.png:20,halo/misc/leadership-flare-2.png:20,halo/misc/leadership-flare-3.png:20,halo/misc/leadership-flare-4.png:20,halo/misc/leadership-flare-4.png:20,halo/misc/leadership-flare-6.png:20,halo/misc/leadership-flare-7.png:20,halo/misc/leadership-flare-8.png:20,halo/misc/leadership-flare-9.png:20,halo/misc/leadership-flare-10.png:20,halo/misc/leadership-flare-11.png:20,halo/misc/leadership-flare-12.png:20,halo/misc/leadership-flare-13.png:20,misc/blank-hex.png:1000" })
	else
		helper.wml_error("Wrong item code " .. number)
	end
	item_appearance = nil
	wesnoth.wml_actions.event({ name = "moveto" , id="ip" .. coord_x .. coord_y , first_time_only= "no", { "filter", { side="1,2,3,4,5", x=coord_x, y=coord_y } }, { "fire_event" , { name="item_pickup", { "primary_unit" , { x=coord_x , y=coord_y }  } } }  })

end

function wesnoth.describe_item(number)
	local increase_intelligence = 0
	local increase_strength = 0
	local increase_dexterity = 0
	local increase_endurance = 0
	local damage = 0
	local damage_plus = 0
	local precision = 0
	local attacks = 0
	local attacks_plus = 0
	local movement = 0
	local resist_fire = 0
	local resist_cold = 0
	local resist_arcane = 0
	local resist_blade = 0
	local resist_impact = 0
	local resist_pierce = 0
	local skills = {}
	local specials = {}
	local defense = 0
	local to_all_skills = 0
	local suck = 0
	local suck_mana = 0
	local penetrate_fire = 0
	local penetrate_cold = 0
	local penetrate_arcane = 0
	local penetrate_blade = 0
	local penetrate_impact = 0
	local penetrate_pierce = 0
	local magic_damage = 0
	local damage_type = nil
	local mana_regen = 0
	local hitpoints = 0
	local courage = false
	local effects = {}
	local description = ""
	local item_type = "violin"
	local item_name = "Kalashnikov"
	local item_appearance = "misc/blank_hex.png"

	local function add_item_modifiers(item_code)
		if item_code.sort then
			item_type = item_code.sort
		end
		if item_code.defense then
			defense = defense + item_code.defense
		end
		if item_code.courage then
			courage=true
		end
		if item_code.movement then
			movement = movement + item_code.movement
		end
		if item_code.resist_fire then
			resist_fire = resist_fire + item_code.resist_fire
		end
		if item_code.resist_cold then
			resist_cold = resist_cold + item_code.resist_cold
		end
		if item_code.resist_arcane then
			resist_arcane = resist_arcane + item_code.resist_arcane
		end
		if item_code.resist_pierce then
			resist_pierce = resist_pierce + item_code.resist_pierce
		end
		if item_code.resist_blade then
			resist_blade = resist_blade + item_code.resist_blade
		end
		if item_code.resist_impact then
			resist_impact = resist_impact + item_code.resist_impact
		end
		if item_code.increase_stregth then
			increase_strength = increase_strength + item_code.increase_strength
		end
		if item_code.increase_dexterity then
			increase_dexterity = increase_dexterity + item_code.increase_dexterity
		end
		if item_code.increase_endurance then
			increase_endurance = increase_endurance + item_code.increase_endurance
		end
		if item_code.increase_intelligence then
			increase_intelligence = increase_intelligence + item_code.increase_intelligence
		end
		if item_code.damage then
			damage = damage + item_code.damage
		end
		if item_code.damage_plus then
			damage_plus = damage_plus + item_code.damage_plus
		end
		if item_code.attacks then
			attacks = attacks + item_code.attacks
		end
		if item_code.attacks_plus then
			attacks_plus = attacks_plus + item_code.attacks_plus
		end
		if item_code.precision then
			precision = precision + item_code.precision
		end
		if item_code.suck then
			suck = suck + item_code.suck
		end
		if item_code.suck_mana then
			suck_mana = suck_mana + item_code.suck_mana
		end
		if item_code.damage_type then
			damage_type = item_code.damage_type
		end
		if item_code.mana_regen then
			mana_regen = mana_regen + item_code.mana_regen
		end
		if item_code.magic then
			magic_damage = magic_damage + item_code.magic
		end
		if item_code.hitpoints then
			hitpoints = hitpoints + item_code.hitpoints
		end
		if item_code.to_all_skills then
			to_all_skills = to_all_skills + item_code.to_all_skills
		end
		for aim_i=1,#item_code do
			if item_code[aim_i][1] == "effect" then
				table.insert(effects,item_code[aim_i])
			end
		end


	end
	if number <70000  and number >= 60000 then
		local item_code_picked = uniques[number-60000][2]
		item_name = item_code_picked.name
		add_item_modifiers(item_code_picked)
		item_appearance = item_code_picked.image or helper.wml_error("Item" .. number .. "is missing its on-ground image")
		if item_code_picked.graphics_mod then
			item_appearance = item_appearance .. item_code_picked.graphics_mod
		end
	end
	if number <200000  and number >= 100000 then
		--will be used for crafted items
	end
	if number <1000000  and number >= 200000 then
		local base_item = base_items[((number - 200000) % 10000 - (number - 200000) % 100)/100][2] or helper.wml_error("Base item of" .. number .. "is not defined")
		item_appearance = base_item.image or helper.wml_error("Item" .. number "is missing its on-ground image")
		add_item_modifiers(base_item)
		item_name = base_item.name
		if base_item.graphics_mod then
			item_appearance = item_appearance .. base_item.graphics_mod
		end
		if number > 210100 then
			local prefix = prefixes[(number - 200000 - (number - 200000) % 10000)/10000][2] or helper.wml_error("Prefix of" .. number .. "is not defined")
			item_name = prefix.name .. " " .. item_name
			add_item_modifiers(prefix)
			if prefix.graphics_mod then
				item_appearance = item_appearance .. prefix.graphics_mod
			end
		end
		if number % 100 > 0 then
			local suffix = suffixes[ number % 100][2] or helper.wml_error("Suffix of" .. number .. "is not defined")
			item_name = item_name .. " " .. suffix.name
			add_item_modifiers(suffix)
			if suffix.graphics_mod then
				item_appearance = item_appearance .. suffix.graphics_mod
			end
		end
	end

	if item_type == "violin" then
		helper.wml_error("describing an item missing its sort (" .. number .. ")")
	end
	if item_name == "Kalashnikov" then
		helper.wml_error("item name identification went wrong (" .. number .. ")")
	else
		local local_item_name = tostring(item_name)
		item_name = local_item_name	
	end
	if item_type == "melee" or item_type == "wand" then
		item_type = "melee weapon"
	end
	if item_type == "ranged" then
		item_type = "ranged weapon"
	end

	description = "Item type: " .. item_type
	if to_all_skills ~= 0 then
		description = description .. "\n" .. to_all_skills .. " to All Skills"
	end
	if damage_type then
		description = description .. "\nDamage Type Set to " .. damage_type
	end
	if defense ~= 0 then
		description = description .. "\n" .. defense .. " to Defense"
	end
	if damage ~=0 then
		description = description .. "\n" .. damage .. "% More Damage"
	end
	if magic_damage ~=0 then
		description = description .. "\n+" .. magic_damage .. "% to Spells' Damage"
	end
	if attacks ~=0 then
		description = description .. "\n" .. attacks .. "% More Attacks"
	end
	if damage_plus ~=0 then
		description = description .. "\n" .. damage_plus .. " More Damage"
	end
	if attacks_plus ~=0 then
		description = description .. "\n" .. attacks_plus .. " More Attacks"
	end
	if suck ~=0 then
		description = description .. "\nSucks " .. suck .. " Life"
	end
	if suck_mana ~=0 then
		description = description .. "\nSucks " .. suck_mana .. " Mana"
	end
	if penetrate_impact ~=0 then
		description = description .. "\n" .. penetrate_impact .. "% to Impact penetrateance"
	end
	if penetrate_blade ~=0 then
		description = description .. "\n" .. penetrate_blade .. "% to Blade penetrateance"
	end
	if penetrate_pierce ~=0 then
		description = description .. "\n" .. penetrate_pierce .. "% to Pierce penetrateance"
	end
	if penetrate_arcane ~=0 then
		description = description .. "\n" .. penetrate_arcane .. "% to Arcane penetrateance"
	end
	if penetrate_fire ~=0 then
		description = description .. "\n" .. penetrate_fire .. "% to Fire penetrateance"
	end
	if penetrate_cold ~=0 then
		description = description .. "\n" .. penetrate_cold .. "% to Cold penetrateance"
	end
	if precision ~=0 then
		description = description .. "\n" .. precision .. " Better Chance to Hit"
	end
	if increase_endurance ~=0 then
		description = description .. "\n" .. increase_endurance .. " More Endurance"
	end
	if increase_intelligence ~=0 then
		description = description .. "\n" .. increase_intelligence .. " More Intelligence"
	end
	if increase_strength ~=0 then
		description = description .. "\n" .. increase_strength .. " More Strength"
	end
	if increase_dexterity ~=0 then
		description = description .. "\n" .. increase_dexterity .. " More Dexterity"
	end
	if movement ~=0 then
		description = description .. "\n" .. movement .. " More Movement Points"
	end
	if mana_regen ~=0 then
		description = description .. "\n" .. mana_regen .. " More Mana Regenerated"
	end
	if hitpoints ~=0 then
		description = description .. "\n" .. hitpoints .. " More Life"
	end
	if courage then
		description = description .. "\nCourage"
	end
	if resist_impact ~=0 then
		description = description .. "\n" .. resist_impact .. "% to Impact Resistance"
	end
	if resist_blade ~=0 then
		description = description .. "\n" .. resist_blade .. "% to Blade Resistance"
	end
	if resist_pierce ~=0 then
		description = description .. "\n" .. resist_pierce .. "% to Pierce Resistance"
	end
	if resist_arcane ~=0 then
		description = description .. "\n" .. resist_arcane .. "% to Arcane Resistance"
	end
	if resist_fire ~=0 then
		description = description .. "\n" .. resist_fire .. "% to Fire Resistance"
	end
	if resist_cold ~=0 then
		description = description .. "\n" .. resist_cold .. "% to Cold Resistance"
	end
	return description,item_name,item_type,item_appearance
end

function wesnoth.wml_actions.describe_item(cfg)
	local number = cfg.number or helper.wml_error("[describe_item] missing the required number attribute")
	local description,item_name,item_type,item_appearance = wesnoth.describe_item(number)
	wesnoth.set_variable("description",description)
	wesnoth.set_variable("item_name",item_name)
	wesnoth.set_variable("item_appearance",item_appearance)
end

function wesnoth.wml_actions.view_inventory(cfg)
	local items_equipped = {}
	local items_inventory = {}
	local items_equipped_description = {}
	local items_inventory_description = {}
	local items_equipped_type = {}
	local items_inventory_type = {}
	local other_things = {}
	local last_equipped = 1
	local last_inventory = 1
	local properties = {}
	local side_number = wesnoth.get_variable("side_number")
	local raw_unit = wesnoth.get_units { canrecruit=true , side=side_number }
	local unit = raw_unit[1].__cfg
	for i=1,#unit do
		if unit[i][1]=="variables" then
			properties = unit[i][2]
		end
	end
	for i=1,#properties do
		if properties[i][1] == "a" then
			if properties[i][2].id < 60000 then
				table.insert(other_things,properties[i][2].id)
			end
			if properties[i][2].id <70000  and properties[i][2].id >= 60000 then
				table.insert(items_equipped,properties[i][2].id)
			end
			if properties[i][2].id <200000  and properties[i][2].id >= 100000 then
				table.insert(items_equipped,properties[i][2].id)
			end
			if properties[i][2].id <1000000  and properties[i][2].id >= 200000 then
				table.insert(items_equipped,properties[i][2].id)
			end

			if properties[i][2].id <1070000  and properties[i][2].id >= 1060000 then
				table.insert(items_inventory,properties[i][2].id-1000000)
			end
			if properties[i][2].id <1200000  and properties[i][2].id >= 1100000 then
				table.insert(items_inventory,properties[i][2].id-1000000)
			end
			if properties[i][2].id <2000000  and properties[i][2].id >= 1200000 then
				table.insert(items_inventory,properties[i][2].id-1000000)
			end
		end
	end
	local dialog = { T.tooltip { id = "tooltip_large" }, T.helptip { id = "tooltip_large" },  maximum_height = 600, --maximum_width = 800,
		T.grid { T.row { T.column { T.label { id="title" , definition="title" , label="Inventory"} }} ,
			T.row { T.column { T.grid { T.row { T.column {T.button { id = "gui_unequip", label = "Unequip" , tooltip="Unequip the selected item."}},
					T.column {T.button { id = "gui_equip_left", label = "Equip as secondary" , tooltip="Equip the selected item, replacing the second item of that sort the character has equipped."}},
					T.column {T.button { id = "gui_equip", label = "Equip" , tooltip="Equip the selected item."}}
				},
				T.row { T.column { horizontal_grow = true, T.listbox { id = "gui_equipped_chosen", 
						T.list_definition { T.row { T.column { horizontal_grow = true,
							T.toggle_panel { tooltip="The list of currently equipped items.", T.grid { T.row {
								T.column { T.image { id = "gui_item_icon" } },
			   					T.column { horizontal_alignment = "left", T.label { id = "gui_item_name" } }
							}}}
						}}}
					}},
					T.column {T.label { id = "gui_description_equipped", label = " " , tooltip="Description of the selected item."}},
					T.column { horizontal_grow = true, T.listbox { id = "gui_inventory_chosen", 
						T.list_definition { T.row { T.column { horizontal_grow = true,
							T.toggle_panel { tooltip="The list of items in inventory.", T.grid { T.row {
								T.column { T.image { id = "gui_item_icon" } },
			   					T.column { horizontal_alignment = "left", T.label { id = "gui_item_name" } }

							}}}
						}}}
					}}
				}
			}}},
			T.row { T.column { T.grid { T.row {
				T.column { T.button { id = "ok", label = "Perform changes" , tooltip="Do all the changes you selected." } },
				T.column { T.button { id = "cancel", label = "Discard changes", tooltip="Undo all selected changes." } }
			}}}}

		}}

	-- T.column {T.button { id = "gui_crafting", label = "Crafting..." , tooltip="Enter the menu for crafing items."}},

	local function preshow()
		local function select_inventory()
			for i=1,10 do
				wesnoth.set_dialog_value("                               ", "gui_equipped_chosen", i, "gui_item_name")
				wesnoth.set_dialog_value( "misc/blank-hex.png", "gui_equipped_chosen", i, "gui_item_icon")
			end
			for i=1,100 do
				wesnoth.set_dialog_value("                               ", "gui_inventory_chosen", i, "gui_item_name")
				wesnoth.set_dialog_value("misc/blank-hex.png", "gui_inventory_chosen", i, "gui_item_icon")
			end
			for i=1,#items_equipped do
				local description,item_name,item_type,item_appearance = wesnoth.describe_item(items_equipped[i])
				wesnoth.set_dialog_value( item_name , "gui_equipped_chosen", i, "gui_item_name")
	--			wesnoth.set_dialog_value( item_appearance , "gui_equipped_chosen", i, "gui_item_icon")
				items_equipped_description[i] = description
				items_equipped_type[i] = item_type
			end
			for i=1,#items_inventory do
				local description,item_name,item_type,item_appearance = wesnoth.describe_item(items_inventory[i])
				wesnoth.set_dialog_value( item_name , "gui_inventory_chosen", i, "gui_item_name")
	--			wesnoth.set_dialog_value( item_appearance , "gui_inventory_chosen", i, "gui_item_icon")
				items_inventory_description[i] = description
				items_inventory_type[i] = item_type
			end
			local preshow_equipped_selected = wesnoth.get_dialog_value "gui_equipped_chosen"
			local preshow_inventory_selected = wesnoth.get_dialog_value "gui_inventory_chosen"
			if items_inventory_description[preshow_inventory_selected] then
				wesnoth.set_dialog_value("--------------------------------------\n" .. items_inventory_description[preshow_inventory_selected] , "gui_description_equipped")
			else
				wesnoth.set_dialog_value( " " , "gui_description_equipped")
			end
		end
		local function select_equipped()
			for i=1,10 do
				wesnoth.set_dialog_value("                                                                                           ", "gui_equipped_chosen", i, "gui_item_name")
				wesnoth.set_dialog_value( "misc/blank-hex.png", "gui_equipped_chosen", i, "gui_item_icon")
			end
			for i=1,100 do
				wesnoth.set_dialog_value("                                                                                           ", "gui_inventory_chosen", i, "gui_item_name")
				wesnoth.set_dialog_value("misc/blank-hex.png", "gui_inventory_chosen", i, "gui_item_icon")
			end
			for i=1,#items_equipped do
				local description,item_name,item_type,item_appearance = wesnoth.describe_item(items_equipped[i])
				wesnoth.set_dialog_value( item_name , "gui_equipped_chosen", i, "gui_item_name")
	--			wesnoth.set_dialog_value( item_appearance , "gui_equipped_chosen", i, "gui_item_icon")
				items_equipped_description[i] = description
				items_equipped_type[i] = item_type
			end
			for i=1,#items_inventory do
				local description,item_name,item_type,item_appearance = wesnoth.describe_item(items_inventory[i])
				wesnoth.set_dialog_value( item_name , "gui_inventory_chosen", i, "gui_item_name")
	--			wesnoth.set_dialog_value( item_appearance , "gui_inventory_chosen", i, "gui_item_icon")
				items_inventory_description[i] = description
				items_inventory_type[i] = item_type
			end
			local preshow_equipped_selected = wesnoth.get_dialog_value "gui_equipped_chosen"
			local preshow_inventory_selected = wesnoth.get_dialog_value "gui_inventory_chosen"
			if items_equipped_description[preshow_equipped_selected] then
				wesnoth.set_dialog_value( "--------------------------------------\n" .. items_equipped_description[preshow_equipped_selected] .. "\n\n\n\n\n\n\n\n\n" , "gui_description_equipped")
			else
				wesnoth.set_dialog_value( " " , "gui_description_equipped")
			end
		end
		local function equip()
			local preshow_inventory_selected = wesnoth.get_dialog_value "gui_inventory_chosen"
			items_equipped[#items_equipped+1] = items_inventory[preshow_inventory_selected]
			table.remove(items_inventory,preshow_inventory_selected)
			items_inventory_description = {}
			items_inventory_type = {}
			select_equipped()
		end
		local function unequip()
			local preshow_equipped_selected = wesnoth.get_dialog_value "gui_equipped_chosen"
			items_inventory[#items_inventory+1] = items_equipped[preshow_equipped_selected]
			table.remove(items_equipped,preshow_equipped_selected)
			items_equipped_description = {}
			items_equipped_type = {}
			select_inventory()
		end
		wesnoth.set_dialog_callback(select_equipped, "gui_equipped_chosen")
		wesnoth.set_dialog_callback(select_inventory, "gui_inventory_chosen")
		wesnoth.set_dialog_callback(equip, "gui_equip")
		wesnoth.set_dialog_callback(equip_left, "gui_equip_left")
		wesnoth.set_dialog_callback(unequip, "gui_unequip")
--		wesnoth.set_dialog_callback(crafting, "gui_crafting")
		select_equipped()
	end

	local function postshow()
	end

	local choice_done = wesnoth.show_dialog(dialog, preshow, postshow)
	if choice_done == -1 then
		local j = 1
		while j <= #properties do
			if properties[j][1] == "a" then
				table.remove(properties,j)
			else
				j = j + 1
			end
		end
		for i=1,#other_things do
			properties[#properties+1] = { "a" , {id = other_things[i] } }
		end
		for i=1,#items_equipped do
			properties[#properties+1] = { "a" , {id = items_equipped[i] } }
		end
		for i=1,#items_inventory do
			properties[#properties+1] = { "a" , {id = items_inventory[i] + 1000000} }
		end
		for i=1,#unit do
			if unit[i][1]=="variables" then
				unit[i][2] = properties
			end
		end
		unit = wesnoth.update_stats(unit)
		wesnoth.put_unit(unit)
	end

end

function wesnoth.wml_actions.drop_random_item(cfg)
	local function choose(var,base_item)
		local list = ""
		local first_time = true
		local function add(i)
			if var[i][2].drop_chance then
				for j = 1,var[i][2].drop_chance do
					if first_time == true then
						list = tostring(i)
						first_time = false
					else
						list = list .. "," .. tostring(i)
					end
				end
			else
				if first_time == true then
					list = tostring(i)
					first_time = false
				else
					list = list .. "," .. tostring(i)
				end
			end
		end
		for i = 1,#var do
			if var[i][2].level <= cfg.level then
				if var[i][2].sorts_affected then
					local can_be = false
					for j in string.gmatch(var[i][2].sorts_affected, "[^%s,][^,]*") do
						if j == base_items[base_item][2].sort then
							can_be = true
						end
					end
					if can_be == true then
						add(i)
					end
				else
					add(i)
				end
			end
		end
		return helper.rand(list)
	end
	local base_item = choose(base_items,base_item)
	local item_code = 100 * base_item
	local has_it = helper.rand("0,1")
	if has_it == 1 then
		item_code = item_code + 10000 * choose(prefixes,base_item) + 200000
	else
		item_code = item_code + 200000
	end
	has_it = helper.rand("0,1")
	if has_it == 1 then
		item_code = item_code + choose(suffixes,base_item)
	end
	wesnoth.wml_actions.put_item{ x=cfg.x, y=cfg.y, id=item_code}
end
