local helper = wesnoth.require "lua/helper.lua"
local T = helper.set_wml_tag_metatable {}
-- local debug_utils = wesnoth.require "~add-ons/World_of_Wesnoth/lua/utils.lua"

function wesnoth.setup_skills_descriptions(skills,magic_damage)
	local spells_names = {}
	local spells_costs = {}
	local spells_descriptions = {}
	local spells_names_ingame = {}
	local enchantment_cost = {}
	if skills.skill_104 then
		spells_names[104] = "spiritual_strike"
		spells_costs[104] = 4
		spells_descriptions[104] = "Deals " .. tostring((7 + 2 * (skills.skill_104 + skills.skill_104 ^ 2))*(1 + magic_damage/100)) .. " arcane damage to a single target."
		spells_names_ingame[104] = "Spiritual Strike"
		enchantment_cost[104] = 0	--isn't an enchantment
	end
	if skills.skill_107 then
		spells_names[107] = "spiritual_recovery"
		spells_costs[107] = 8 + skills.skill_107
		spells_descriptions[107] = "Recovers " .. tostring(15 + skills.skill_107 * 10) .. "% hitpoints (self only)."
		spells_names_ingame[107] = "Spiritual Recovery"
		enchantment_cost[107] = 0
	end
	if skills.skill_203 then
		spells_names[203] = "flaming_weapon"
		spells_costs[203] = 0
		spells_descriptions[203] = "Adds " .. tostring((4 + skills.skill_203 ^2)*(1 + magic_damage/100)) .. " fire damage to each hit with any melee attack."
		spells_names_ingame[203] = "Flaming Weapon"
		enchantment_cost[203] = 1
	end
	if skills.skill_208 then
		spells_names[208] = "fireball"
		spells_costs[208] = 5
		spells_descriptions[208] = "Deals " .. tostring((7 + 2 * (skills.skill_208 ^ 2 + skills.skill_208 * 2 ))*(1 + magic_damage/100)) .. " fire damage to the target and a half of it to all enemies adjacent to it."
		spells_names_ingame[208] = "Fireball"
		enchantment_cost[208] = 0
	end

	return spells_names,spells_costs,spells_descriptions,spells_names_ingame,enchantment_cost
end

function wesnoth.wml_actions.show_spells(cfg)
	local side_number = wesnoth.get_variable("side_number")
	local raw_unit = wesnoth.get_units { canrecruit=true , side=side_number }
	local unit = raw_unit[1].__cfg
	local target
	local self = cfg.self
	local friendly = cfg.friendly
	local empty = cfg.empty
	local enemy
	local spell_chosen
	if not empty and not friendly then
		enemy = true
	end
	local mana,max_mana = wesnoth.get_mana(unit)
	if not empty then
		local raw_target = wesnoth.get_units { x=cfg.x, y=cfg.y }
		target = raw_target[1].__cfg
	end
	local skills = {}
	for i = 1,#unit do
		if unit[i][1] == "variables" then
			skills = unit[i][2]
		end
	end
	local spells_names,spells_costs,spells_descriptions,spells_names_ingame,enchantment_cost = wesnoth.setup_skills_descriptions(skills,skills.magic_damage)
	local dialog = { T.tooltip { id = "tooltip_large" }, T.helptip { id = "tooltip_large" },  maximum_height = 600, maximum_width = 800,
		T.grid { T.row { T.column { T.label { id="title" , definition="title" , label="Spells"} }} ,
			T.row { T.column { T.label { id = "gui_mana_display", label="Mana: 0/0"}}},
			T.row { T.column { T.scroll_label { id = "gui_description", label="                                                                                                                                   \n                                                                                                                                   \n                                                                                                                                   \n"}}},
			T.row { T.column { T.grid { T.row {
				T.column { T.button { id = "gui_enchantments", label = "Enchantments" , tooltip="See a list of enchantments that are draining your mana." } }
			}}}},
			T.row {	T.column { horizontal_grow = true, T.listbox { id = "gui_spell_chosen", 
				T.list_definition { T.row { T.column { horizontal_grow = true,
					T.toggle_panel { tooltip="The list of spells that can be cast on the selected location.", T.grid { T.row {
						T.column { T.image { id = "gui_spell_icon" } },
	   					T.column { T.grid { 
							T.row { T.column { horizontal_alignment = "left", T.label { id = "gui_spell_name" } }},
							T.row { T.column { horizontal_alignment = "left", T.label { id = "gui_spell_cost" } }}
						}}
					}}}
				}}}
			}}},
			T.row { T.column { T.grid { T.row {
				T.column { T.button { id = "ok", label = "Cast Spell" , tooltip="Cast the selected spell." } },
				T.column { T.button { id = "cancel", label = "Back", tooltip="Back to game." } }
			}}}}
		}}
	local function preshow()
		local function select()
			spell_chosen = wesnoth.get_dialog_value "gui_spell_chosen"
			wesnoth.set_dialog_active( true , "ok")
			wesnoth.set_dialog_value( spells_descriptions[spell_chosen] , "gui_description")
		end
		local function enchantments()
			local done = false
				while done == false do
				local raw_units = wesnoth.get_units({{ "filter_wml", { { "variables", {  enchanted=true }  } } }})
				local enchantments = {}
				local enchantment_chosen
				if #raw_units > 0 then
					for i=1,#raw_units do
						local unit = raw_units[i].__cfg
						for j=1,#unit do
							if unit[j][1] == "variables" then
								for k=1,#unit[j][2] do
									if unit[j][2][k][1] == "enchantment" then
										if unit[j][2][k][2].caster == side_number then
											table.insert(enchantments, { image="misc/blank-hex.png", name=unit.name, number=unit[j][2][k][2].number, id=unit.id })
										end

									end
								end
							end
						end
					end
					if  #enchantments > 0 then
						local enchantments_dialog = { T.tooltip { id = "tooltip_large" }, T.helptip { id = "tooltip_large" },  maximum_height = 600, maximum_width = 800,
							T.grid { T.row { T.column { T.label { id="title" , definition="title" , label="Enchantments"} }} ,
								T.row { T.column { T.scroll_label { id = "gui_description", label="                                                                                                                                   \n                                                                                                                                   \n                                                                                                                                   \n"}}},
								T.row {	T.column { horizontal_grow = true, T.listbox { id = "gui_enchantment_chosen", 
									T.list_definition { T.row { T.column { horizontal_grow = true,
										T.toggle_panel { tooltip="The list of enchantments that are draining your mana.", T.grid { T.row {
											T.column { T.image { id = "gui_enchantment_icon" } },
											T.column { T.image { id = "gui_enchantment_target" } },
						   					T.column { T.grid { 
												T.row { T.column { horizontal_alignment = "left", T.label { id = "gui_enchantment_name" } }},
												T.row { T.column { horizontal_alignment = "left", T.label { id = "gui_enchantment_cost" } }}
											}}
										}}}
									}}}
								}}},
							T.row { T.column { T.grid { T.row {
								T.column { T.button { id = "ok", label = "Cancel enchantment" , tooltip="Cancels the selected enchantment." } },
								T.column { T.button { id = "cancel", label = "Back", tooltip="Back to spells menu." } }
							}}}}
							}}
						local function enchantments_preshow()
							local function select()
								enchantment_chosen = wesnoth.get_dialog_value "gui_enchantment_chosen"
								wesnoth.set_dialog_active( true , "ok")
								wesnoth.set_dialog_value( spells_descriptions[enchantments[enchantment_chosen].number] , "gui_description")
							end
							wesnoth.set_dialog_callback(select, "gui_enchantment_chosen")
							wesnoth.set_dialog_active( false , "ok")
							for i=1,#enchantments do
								wesnoth.set_dialog_value("misc/blank-hex.png" , "gui_enchantment_chosen", i , "gui_enchantment_icon")
								wesnoth.set_dialog_value(enchantments[i].image , "gui_enchantment_chosen", i , "gui_enchantment_target")
								wesnoth.set_dialog_value(spells_names_ingame[enchantments[i].number] .. " (" .. enchantments[i].name .. ")"  , "gui_enchantment_chosen", i , "gui_enchantment_name")
								wesnoth.set_dialog_value("Mana cost: " .. enchantment_cost[enchantments[i].number]  , "gui_enchantment_chosen", i , "gui_enchantment_cost")
							end

						end
						local function enchantments_postshow()
						end
						local choice = wesnoth.show_dialog(enchantments_dialog, enchantments_preshow, enchantments_postshow)
						if choice == -1 then
							local raw_target = wesnoth.get_units { id=enchantments[enchantment_chosen].id }
							local target = raw_target[1].__cfg
							for i = 1,#target do
								if target[i][1] == "variables" then
									for j=1,#target[i][2] do
										if target[i][2][j][1] == "enchantment" then
											if target[i][2][j][2].number == enchantments[enchantment_chosen].number then
												target[i][2][spells_names[enchantments[enchantment_chosen].number]] = nil
												target[i][2][spells_names[enchantments[enchantment_chosen].number].. "_level"] = nil
												target[i][2][j] = nil
												j=j-1
											end
										end
									end
									local enchanted = false
									for j=1,#target[i][2] do
										if target[i][2][j][1] == "enchantment" then
											enchanted = true
										end
									end
									if enchanted == false then
										target[i][2].enchanted = nil
									end
								end
							end
							wesnoth.put_unit(target)
							if unit.id == target.id then
								unit = target
							end
						else
							done = true
						end
					else
						done = true
						wesnoth.set_dialog_value( "You are not actively keeping an enchantment on anything." , "gui_description")
					end
				else
					wesnoth.set_dialog_value( "You are not actively keeping an enchantment on anything." , "gui_description")
					done = true
				end
			end
		end
		wesnoth.set_dialog_active( false, "ok")
		wesnoth.set_dialog_callback(select, "gui_spell_chosen")
		wesnoth.set_dialog_callback(enchantments, "gui_enchantments")
		wesnoth.set_dialog_value( "Mana: " .. mana .. "/" .. max_mana , "gui_mana_display")
		if skills.skill_104 and enemy and mana > 4 then
			wesnoth.set_dialog_value("Spiritual Strike (" .. tostring(skills.skill_104) .. ")", "gui_spell_chosen", 104 , "gui_spell_name")
			wesnoth.set_dialog_value("misc/blank-hex.png)", "gui_spell_chosen", 104, "gui_spell_icon")
			wesnoth.set_dialog_value("Mana cost: 4", "gui_spell_chosen", 104 , "gui_spell_cost")
		end
		if skills.skill_107 and self then
			if mana > tonumber(8 + skills.skill_107) then
				wesnoth.set_dialog_value("Spiritual Recovery (" .. tostring(skills.skill_107) .. ")", "gui_spell_chosen", 107 , "gui_spell_name")
				wesnoth.set_dialog_value("misc/blank-hex.png)", "gui_spell_chosen", 107, "gui_spell_icon")
				wesnoth.set_dialog_value("Mana cost: " .. tostring(8 + skills.skill_107), "gui_spell_chosen", 107 , "gui_spell_cost")
			end
		end
		if skills.skill_203 and friendly and mana > 1 then
			wesnoth.set_dialog_value("Flaming Weapon (" .. tostring(skills.skill_203) .. ")", "gui_spell_chosen", 203 , "gui_spell_name")
			wesnoth.set_dialog_value("misc/blank-hex.png)", "gui_spell_chosen", 203, "gui_spell_icon")
			wesnoth.set_dialog_value("Mana cost: 1 per turn", "gui_spell_chosen",203 , "gui_spell_cost")
		end
		if skills.skill_208 and (enemy or empty) and mana > 5 then
			wesnoth.set_dialog_value("Fireball (" .. tostring(skills.skill_208) .. ")", "gui_spell_chosen", 208 , "gui_spell_name")
			wesnoth.set_dialog_value("misc/blank-hex.png)", "gui_spell_chosen", 208, "gui_spell_icon")
			wesnoth.set_dialog_value("Mana cost: 5", "gui_spell_chosen",208 , "gui_spell_cost")
		end

	end

	local function postshow()
	end

	local chose = wesnoth.show_dialog(dialog, preshow, postshow)
	if spell_chosen and chose == -1 then
		unit.attacks_left = unit.attacks_left - 1
		for i = 1,#unit do
			if unit[i][1] == "variables" then
				unit[i][2].mana = unit[i][2].mana - spells_costs[spell_chosen]
			end
		end
		unit = wesnoth.display_mana(unit)
		wesnoth.put_unit(unit)
		if enchantment_cost[spell_chosen] > 0 then
			for i=1,#target do
				if target[i][1] == "variables" then
					target[i][2].enchanted = true
					if spell_chosen == 203 then
						target[i][2].flaming_weapon = true
						target[i][2].flaming_weapon_level = skills.skill_203
						table.insert( target[i][2] , { "enchantment" , { name="flaming_weapon", caster=side_number, cost=1, number=203 } } )
					end
				end
			end


			wesnoth.put_unit(target)
		else
			wesnoth.fire_event(spells_names[spell_chosen],unit.x,unit.y,target.x,target.y)
		end
	end
end
